"use strict";
/*
    This file is part of MUTE-structs.

    Copyright (C) 2017  Matthieu Nicolas, Victorien Elvinger

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var data_validation_1 = require("../../data-validation");
var epoch_1 = require("../../epoch/epoch");
var renamablelogootsoperation_1 = require("../renamablelogootsoperation");
var logootsdel_1 = require("./logootsdel");
var RenamableLogootSDel = /** @class */ (function (_super) {
    __extends(RenamableLogootSDel, _super);
    function RenamableLogootSDel(op, epoch) {
        return _super.call(this, op, epoch) || this;
    }
    RenamableLogootSDel.fromPlain = function (o) {
        if (data_validation_1.isObject(o)) {
            var op = logootsdel_1.LogootSDel.fromPlain(o.op);
            var epoch = epoch_1.Epoch.fromPlain(o.epoch);
            if (op !== null && epoch !== null) {
                return new RenamableLogootSDel(op, epoch);
            }
        }
        return null;
    };
    RenamableLogootSDel.prototype.execute = function (renamableList) {
        return renamableList.delRemote(this.epoch, this.op);
    };
    return RenamableLogootSDel;
}(renamablelogootsoperation_1.RenamableLogootSOperation));
exports.RenamableLogootSDel = RenamableLogootSDel;
//# sourceMappingURL=renamablelogootsdel.js.map